<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->
<script setup lang="ts">
import * as api from '../api';
import * as util from '../util';
import { useApplicationStore } from '../stores/application';
import { computed, onMounted, reactive, ref } from 'vue';
import { AuthorizationConfig } from '../entities/config';

const applicationStore = useApplicationStore();

const state = reactive({
  loading: false,
  ssoLoading: false,
  unauthorized: false,
  ssoError: false,
  login: {
    mail: '',
    password: '',
  },
});

const form = ref(null);

const basicLogin = computed<AuthorizationConfig | undefined>(() => {
  const filteredAuthorizer =
    applicationStore.config?.authorizations?.filter((e) => e.type === 'CREDENTIAL') ?? [];

  return filteredAuthorizer.length > 0 ? filteredAuthorizer[0] : undefined;
});

const ssoLogins = computed(
  () => applicationStore.config?.authorizations?.filter((e) => e.type !== 'CREDENTIAL') ?? []
);

onMounted(() => {
  const searchParams = new URLSearchParams(window.location.search);
  const provider = searchParams.get('provider');

  if (provider && searchParams.has('code')) {
    state.ssoLoading = true;
    const code = searchParams.get('code');
    const foundProvider = ssoLogins.value.find((e) => e.id === provider);

    if (!foundProvider) {
      removeSsoUrlParams();
      state.ssoError = true;
      state.ssoLoading = false;
    } else {
      authorize(provider, foundProvider.type, code);
    }
  }
});

function redirectUrl(provider: string) {
  return util.CONFIG.API_BASE_URL + '/v1/authorizer/' + provider;
}

function removeSsoUrlParams() {
  let loc = new URL(window.location.href);
  loc.searchParams.delete('provider');
  loc.searchParams.delete('code');
  loc.searchParams.delete('session_state');

  window.history.replaceState(window.history.state, '', loc.href);
}

function authorize(authorizer: string, authorizerType: 'CREDENTIAL' | 'OIDC' | 'TOKEN', body: any) {
  state.loading = true;

  const loginPromise = api.session.login(authorizer, body).then((data) => {
    if (!data) {
      if (authorizerType == 'CREDENTIAL') {
        state.unauthorized = true;
        state.loading = false;
      } else {
        state.ssoError = true;
        state.ssoLoading = false;
      }
    } else {
      applicationStore.setSession(data);
    }
  });

  api.allCatching([loginPromise]).finally(() => {
    state.loading = false;
  });
}

function doLogin() {
  // @ts-ignore
  if (basicLogin.value && form.value.validate()) {
    authorize(basicLogin.value.id, 'CREDENTIAL', state.login);
  }
}
</script>

<template>
  <v-form ref="form" v-on:submit.prevent="doLogin">
    <v-card-text>
      <v-alert type="error" v-model="state.unauthorized" dismissible>
        Benutzername oder Passwort falsch
      </v-alert>
      <v-alert type="error" v-model="state.ssoError" dismissible>
        SSO-Login nicht erfolgreich, bitte erneut versuchen
      </v-alert>
      <v-text-field
        v-if="basicLogin && !state.ssoLoading"
        label="E-Mail"
        name="mail"
        type="email"
        prepend-icon="mdi-email"
        v-model="state.login.mail"
        :disabled="state.loading"
        :rules="[util.validateMail]"
      />

      <v-text-field
        v-if="basicLogin && !state.ssoLoading"
        id="password"
        label="Passwort"
        name="password"
        prepend-icon="mdi-lock"
        type="password"
        v-model="state.login.password"
        :rules="[util.validatePassword]"
        :disabled="state.loading"
      />
      <div v-if="!state.ssoLoading">
        <v-btn
          v-for="login in ssoLogins.filter((it) => it.name)"
          v-bind:key="login.id"
          tile
          block
          :color="login.color"
          class="ma-0 mb-2 white--text"
          :href="redirectUrl(login.id)"
        >
          Login mit {{ login.name }}
          <v-icon right v-if="login.iconUrl && !login.iconUrl.startsWith('https')"
            >mdi-{{ login.iconUrl }}</v-icon
          >
          <span v-else>{{ login.iconUrl }}</span>
        </v-btn>
      </div>
      <div v-else class="text-center">
        <v-progress-circular indeterminate color="primary"></v-progress-circular>
      </div>
    </v-card-text>

    <v-card-actions>
      <router-link class="deep-orange--text" to="/forgot" v-if="!state.ssoLoading"
        >Passwort vergessen?</router-link
      >
      <v-spacer />
      <v-btn
        type="submit"
        color="orange darken-2"
        class="pa-4 white--text"
        tile
        :loading="state.loading"
        :disabled="state.loading"
        v-if="basicLogin && !state.ssoLoading"
        >Login
      </v-btn>
    </v-card-actions>
  </v-form>
</template>
